package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.common.distribution.genid.IdGenerator;
import com.weaver.ebuilder.datasource.api.entity.SqlParamEntity;
import com.weaver.ebuilder.form.client.entity.obj.Obj;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.seconddev.jcldoor.util.JucailinPortalUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.apache.tools.ant.types.selectors.modifiedselector.Cache;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 自助服务入口
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/19
 */
@Component
public class SelfServiceInfoCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(SelfServiceInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    @Autowired
    private JucailinPortalUtils jucailinPortalUtils;

    public String tenant_key = "t7akvdnf84";

    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> recordMap = new HashMap<String,Object>();
        String pkey = "uf_zzfwcsh.taby.fieldId";
        String field_id =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwcsh.taby.url";
        String taburl =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";

        String employeeId = request.getParameter("employeeId");
        //type: 0 系统默认 ，1 自定义配置
        String type = "0";

        if(StringUtils.isBlank(employeeId)){
            employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
        }

        //返回自助服务tab信息
        List<Map<String,Object>> dataList  = new ArrayList<Map<String,Object>>();

        //返回近期访问数据
        List<Map<String,Object>> record  = new ArrayList<Map<String,Object>>();

        try{
            String sql = " select distinct taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key =?";

            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);


            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);


            log.error("sql:"+sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                // /api/file/preview?type=redirect&imgFormat=small&fileId=977697615197618177&module=ebuilderform&authModule=ebuilderform&source=form&fieldId=977686869110833154&customParam=%7B%22dataId%22%3A%22977697666574729218%22%7D&refId=977697666574729218&folderId=8120831157448215424
                dataList = getCustomeServiceData(groupId,sourceType,field_id,recordList,employeeId);
                record = getCustomeServiceRecord(groupId,sourceType,employeeId);
                type = "1";
            }else{
                dataList = getDefaultServiceData(groupId,sourceType,field_id);
                record = getDefaultServiceRecord(groupId,sourceType,employeeId);
                type = "0";
            }
        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
        }
        recordMap.put("list",dataList);
        recordMap.put("record",record);
        recordMap.put("type",type);
        recordMap.put("taburl",taburl);
        return recordMap;
    }

    public List<Map<String,Object>> getCustomeServiceData(String groupId,String sourceType,String field_id,List<Map<String,Object>> recordList,String employeeId){

        Map<String,String> optionMap = getCustomServiceTypeName(groupId,sourceType,employeeId);

        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String taby = String.valueOf(recordMap.get("taby"));
            log.error("getCustemSelfServiceType-taby:"+taby);

            String tabyName = optionMap.get(taby);
            List<Map<String,Object>> customList = getCustomeServiceDataByType(groupId,sourceType,taby,employeeId);

            log.error("getCustemSelfServiceType-tabyName:"+tabyName);
            log.error("getCustemSelfServiceType-taby:"+taby);
            recordMap.put("menus",customList);
            recordMap.put("name",tabyName);
        }
        return recordList;
    }

    public List<Map<String,Object>> getCustomeServiceDataByType(String groupId,String sourceType,String value,String employeeId){
        String sql = " select id,fwmc,fwdz,fwtb,taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and taby=? and delete_type=0 and tenant_key = ? order by ifnull(xssx,0) ";
        log.info("getSelfServiceData--sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(employeeId);
        strlist.add(value);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);


        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String fwtb = String.valueOf(recordMap.get("fwtb"));
            String fwtburl = "";
            if(StringUtils.isNotBlank(fwtb)){
                fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
            }
            recordMap.put("fwtburl",fwtburl);
        }
        return recordList;
    }

    /***
     *  默认数据
     * @param groupId
     * @param sourceType
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceData(String groupId,String sourceType,String field_id){

        String sql = " select name,value_key as taby from field_option where field_id=? and  delete_type=0 and tenant_key = ?";
        log.info("sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(field_id);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String taby = String.valueOf(recordMap.get("taby"));
            List<Map<String,Object>> defaultList =  getDefaultServiceDataByType(groupId,sourceType,taby);
            recordMap.put("menus",defaultList);
        }
        return recordList;
    }

    /***
     * 默认数据
     * @param groupId
     * @param sourceType
     * @param value
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceDataByType(String groupId,String sourceType,String value){
        String sql =" select t.taby,t.fwtb,t.fwmc,t.fwdz " +
                    " from uf_zzfwcsh t \n" +
                    " where t.delete_type=0 \n" +
                    " and t.taby= ?" +
                    " and t.tenant_key = ?" +
                    " order by ifnull(t.xssx,0) ";

        log.error("getSelfServiceData--sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(value);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String fwtb = String.valueOf(recordMap.get("fwtb"));
            String fwtburl = "";
            if(StringUtils.isNotBlank(fwtb)){
                fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
            }
            recordMap.put("fwtburl",fwtburl);
        }
        return recordList;
    }

    /***
     *
     * @param groupId
     * @param sourceType
     * @return
     */
    public Map<String,String> getCustomServiceTypeName(String groupId,String sourceType,String employeeId){

        Map<String,String> optionMap = new HashMap<String,String>();
        String sql = " select id,tabymmc from uf_zzfwrktaby where qy is not null and ry=? and delete_type=0 and tenant_key = ? order by ifnull(xssx,0) ";
        log.error("getCustomServiceTypeName-sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(employeeId);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String value = String.valueOf(recordMap.get("id"));
            String name = String.valueOf(recordMap.get("tabymmc"));
            log.error("getCustomServiceTypeName-value:"+value+" name:"+name);
            optionMap.put(value,name);
        }
        return optionMap;
    }


    /**
     * 近期访问数据（自定义配置时）
     * @param groupId
     * @param sourceType
     * @param employeeId
     * @return
     */
    public List<Map<String,Object>> getCustomeServiceRecord(String groupId,String sourceType,String employeeId){
        String sql = " select id,fwmc,fwdz,fwtb,taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key = ? order by djcs desc limit 6";
        log.info("getCustomeServiceRecord--sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(employeeId);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);


        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String fwtb = String.valueOf(recordMap.get("fwtb"));
            String fwtburl = "";
            if(StringUtils.isNotBlank(fwtb)){
                fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
            }
            recordMap.put("fwtburl",fwtburl);
        }
        return recordList;
    }

    /**
     * 新增点击次数
     * @param request
     * @param simpleEmployee
     * @return
     */
    public Map<String, Object> addSelfServiceCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> recordMap = new HashMap<String,Object>();
        String id = request.getParameter("id");
        if(StringUtils.isBlank(id)){
            recordMap.put("status",false);
        }else {
            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";
            String sql = "update uf_zzfwrkpz set djcs = ifnull(djcs,0) + 1 where id = ?";

            List<String> strlist = new ArrayList<>(100);
            strlist.add(id);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            recordMap.put("status",true);
        }
        return recordMap;
    }

    /**
     * 默认类型 经常访问数据
     * @param groupId
     * @param sourceType
     * @param employeeId
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceRecord(String groupId,String sourceType,String employeeId){
        String sql = "select t.taby,t.fwtb,t.fwmc,t.fwdz from uf_zzfwcsh t where t.delete_type=0 and t.tenant_key = ? limit 6";
        log.info("getDefaultServiceRecord--sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        return recordList;
    }


    /***
     *
     * @param employeeId
     * @return
     */
    public Map<String,Object> initSelfServiceData(String employeeId){

        Map<String,Object> recordMap = new HashMap<String,Object>();
        String pkey = "uf_zzfwcsh.taby.fieldId";
        String field_id =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwcsh.taby.url";
        String taburl =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";

        String uf_zzfwrktaby_qy = "977701948757786627";

        String uf_zzfwrkpz_qy = "977704104898478082";

        try{
            String sql = " select distinct taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key =?";

            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                recordMap.put("code","200");
                recordMap.put("type","1");
            }else{
                int count = initCustomServiceData(groupId,sourceType,field_id,employeeId,uf_zzfwrktaby_qy,uf_zzfwrkpz_qy);
                if(count > 0){
                    recordMap.put("code","-100");
                }else{
                    recordMap.put("code","200");
                }
                recordMap.put("type","0");
            }
        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            recordMap.put("code","-200");
        }

        return recordMap;
    }


    /***
     *  默认数据
     * @param groupId
     * @param sourceType
     * @return
     */
    public int initCustomServiceData(String groupId,String sourceType,String field_id,String employeeId,String uf_zzfwrktaby_qy,String uf_zzfwrkpz_qy){
        int errcount = 0;
        try{
            String sql = " select name,value_key as taby from field_option where field_id=? and delete_type=0 and tenant_key = ?";
            log.info("sql:"+sql);
            List<String> paramList = new ArrayList<>(100);
            paramList.add(field_id);
            paramList.add(tenant_key);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String taby = String.valueOf(recordMap.get("taby"));
                String name = String.valueOf(recordMap.get("name"));

                String tabid = getTabId(employeeId,name,groupId,sourceType,uf_zzfwrktaby_qy);
                log.error("tabid:"+tabid);
                if(StringUtils.isNotBlank(tabid)){
                    int count = initCustomServiceDataByType(employeeId,groupId,sourceType,taby,tabid,uf_zzfwrkpz_qy);
                    if(count>0){
                        errcount++;
                    }
                }else{
                    String code = insertTabData(employeeId,name,i+"",groupId,sourceType,uf_zzfwrktaby_qy);
                    if("200".equals(code)){
                        tabid = getTabId(employeeId,name,groupId,sourceType,uf_zzfwrktaby_qy);
                        log.error("tabid:"+tabid);
                        if(StringUtils.isNotBlank(tabid)){
                            int count = initCustomServiceDataByType(employeeId,groupId,sourceType,taby,tabid,uf_zzfwrkpz_qy);
                            if(count>0){
                                errcount++;
                            }
                        }
                    }else{
                        errcount++;
                    }
                }
            }
        }catch (Exception e){
            errcount++;
        }
        return errcount;
    }


    /***
     *
     * @param employeeId
     * @param name
     * @param xssx
     * @param groupId
     * @param sourceType
     * @return
     */
    public String insertTabData(String employeeId,String name,String xssx,String groupId,String sourceType,String uf_zzfwrktaby_qy){


        String code = "" ;
        try{
            log.error("insertTabData");
            long generate = IdGenerator.generate();

            log.error("insertTabData--id:"+generate+"  ry:"+employeeId+" tabymmc:"+name+"  xssx:"+xssx);

//            String sql =" insert into uf_zzfwrktaby(id,ry,tabymmc,qy,xssx,form_data_id,data_index,create_time,update_time,tenant_key,is_delete,creator,delete_type)  " +
//                        " values(?,?,?,?,?,?,?,?,0,now(),now(),?,0,?,0)";
//            List<String> paramList = new ArrayList<>(100);
//            paramList.add(generate+"");
//            paramList.add(employeeId);
//            paramList.add(name);
//            paramList.add(uf_zzfwrktaby_qy);
//            paramList.add(xssx);
//            paramList.add(generate+"");
//            paramList.add(tenant_key);
//            paramList.add(employeeId);
//            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
//            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

            String sql =" insert into uf_zzfwrktaby(id,ry,tabymmc,qy,xssx,form_data_id,data_index,create_time,update_time,tenant_key,is_delete,creator,delete_type)  " +
                        " values("+generate+","+employeeId+",'"+name+"',"+uf_zzfwrktaby_qy+",'"+xssx+"',"+generate+",0,now(),now(),'"+tenant_key+"',0,"+employeeId+",0)";

            log.error("sql:"+sql);
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            if(result.containsKey("code")){
                code = String.valueOf(result.get("code"));
            }
            log.error("code:"+code);

        }catch (Exception e){
            code = "-200";
            log.error("insertTabData-e:"+e);
        }
        return code;
    }
        /***
         *
         * @param employeeId
         * @param name
         * @param groupId
         * @param sourceType
         * @return
         */
    public String getTabId(String employeeId,String name,String groupId,String sourceType,String uf_zzfwrktaby_qy){

        String tabid = "" ;
        try{
            String sql = "select id from uf_zzfwrktaby where ry = ? and tabymmc = ? and qy = ? and delete_type=0 and tenant_key = ?";
            log.info("sql:"+sql);

            List<String> paramList = new ArrayList<>(100);
            paramList.add(employeeId);
            paramList.add(name);
            paramList.add(uf_zzfwrktaby_qy);
            paramList.add(tenant_key);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(!recordList.isEmpty() && recordList.size()>0){
                Map<String, Object> recordMap = recordList.get(0);
                tabid = String.valueOf(recordMap.get("id"));
            }
        }catch (Exception e){
            log.error("getTabId-e:"+e);
        }
        return tabid;
    }

    /**
     *
     * @param employeeId
     * @param groupId
     * @param sourceType
     * @param selectvalue
     * @param tabid
     * @return
     */
    public int initCustomServiceDataByType(String employeeId,String groupId,String sourceType,String selectvalue,String tabid,String uf_zzfwrktaby_qy){

        int errcount = 0 ;
        try{
            String sql =" select t.taby,t.fwtb,t.fwmc,t.fwdz " +
                        " from uf_zzfwcsh t \n" +
                        " where t.delete_type=0 \n" +
                        " and t.taby= ?" +
                        " and t.tenant_key = ?" +
                        " order by ifnull(t.xssx,0) ";

            List<String> paramList = new ArrayList<>(100);
            paramList.add(selectvalue);
            paramList.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String fwtb = String.valueOf(recordMap.get("fwtb"));
                String fwmc = String.valueOf(recordMap.get("fwmc"));
                String fwdz = String.valueOf(recordMap.get("fwdz"));
                String code = insertCustomServiceData(employeeId,fwmc,fwdz,fwtb,i+"",groupId,sourceType,tabid,uf_zzfwrktaby_qy);
                if(!"200".equals(code)){
                    errcount++;
                }
            }
        }catch (Exception e){
            errcount++;
        }
        return errcount;
    }

    /**
     *
     * @param employeeId
     * @param name
     * @param fwdz
     * @param fwtb
     * @param xssx
     * @param groupId
     * @param sourceType
     * @param tabid
     * @return
     */
    public String insertCustomServiceData(String employeeId,String name,String fwdz,String fwtb,String xssx,String groupId,String sourceType,String tabid,String uf_zzfwrktaby_qy){

        String code = "";
        try {
            long generate = IdGenerator.generate();
            log.error("insertCustomServiceData--id:"+generate+"  ry:"+employeeId+" fwmc:"+name+" fwdz:"+fwdz+" fwtb:"+fwtb+" taby:"+tabid+" xssx:"+xssx);

//            String sql =" insert into uf_zzfwrkpz(id,ry,fwmc,fwdz,fwtb,taby,qy,xssx,form_data_id,data_index,create_time,update_time,tenant_key,is_delete,creator,delete_type)  " +
//                        " values(?,?,?,?,?,?,?,?,?,0,now(),now(),?,0,?,0)";
//            List<String> paramlist = new ArrayList<>(100);
//            paramlist.add(generate+"");
//            paramlist.add(employeeId);
//            paramlist.add(name);
//            paramlist.add(fwdz);
//            paramlist.add(fwtb);
//            paramlist.add(tabid);
//            paramlist.add(uf_zzfwrktaby_qy);
//            paramlist.add(xssx);
//            paramlist.add(generate+"");
//            paramlist.add(tenant_key);
//            paramlist.add(employeeId);
//            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramlist);
//            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

            String sql =" insert into uf_zzfwrkpz(id,ry,fwmc,fwdz,fwtb,taby,qy,xssx,form_data_id,data_index,create_time,update_time,tenant_key,is_delete,creator,delete_type)  " +
                        " values("+generate+","+employeeId+",'"+name+"','"+fwdz+"','"+fwtb+"','"+tabid+"',"+uf_zzfwrktaby_qy+",'"+xssx+"',"+generate+",0,now(),now(),'"+tenant_key+"',0,"+employeeId+",0)";
            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
            if(result.containsKey("code")){
                code = String.valueOf(result.get("code"));
            }
        }catch (Exception e){
            e.printStackTrace();
            log.error("insertCustomServiceData-e:"+e);
            code = "-200";
        }
        return code ;
    }

}
